#include <stdio.h>

#ifndef CALLOC
#   define CALLOC(A,B) (B*) calloc((A),sizeof(B))
#endif

#ifndef MAX
#   define MAX(A,B) ( (A)>(B) ? (A) : (B))
#endif

#ifndef MIN
#   define MIN(A,B) ( (A)<(B) ? (A) : (B))
#endif

#ifndef ABS
#   define ABS(A) ((A)<0 ? (-A) : (A))
#endif

#ifndef REALLOC
#   define REALLOC(P,S)  ((P)?realloc(P,S):malloc(S))   /* safe realloc */
#endif

#define strequal(A,B) (!strcmp((A),(B)))

extern void nst_free(void*);

extern void aux_error(char *pcFmt, ...);
extern void  aux_write_text_lines(FILE *fp, int iIndent, char *pcText);
extern char *aux_read_text_lines(FILE *fp, char *pcFirstLine);
extern int   aux_eval_expr(char*,float*);
extern float aux_show_timer(void);
extern void  aux_reset_timer(void);
extern void  aux_run_timer(void);
extern void  aux_stop_timer(void);

extern char *aux_append_str(char*,char*);
extern char *aux_prepend_str(char*,char*);
extern char *aux_int_to_str(int);
extern char *aux_ptr_to_str(void*);
extern int aux_is_null(char*);
extern char *aux_skip_spaces(char*);
extern char *aux_skip_digits(char*);
extern char *aux_next_space(char*);
extern int  aux_parse_geometry(char*,int*,int*,int*,int*);
extern int  aux_is_blank(char*);
extern int  aux_is_int_num(char*);
extern int  aux_is_float_num(char*);
extern char *aux_str_from_file(FILE*,int);
extern FILE *aux_str_to_file(char*, char**);
extern void *aux_str_to_ptr(char*);
extern int  aux_read(int,void*,int);
extern void aux_free_args(int,char**);
extern int  aux_skip_comments(FILE*,char);
extern char *aux_parse_options(char*,char*,int*,float*,float*,float*,float*);

extern void aux_fprintf_str(FILE*,char*);
extern char *aux_fscanf_str(FILE*,char*);

#if 0
extern char **aux_printf_dialog_values(char*,int,float*,int,char**);
extern void aux_scanf_dialog_values(char**, int*, float*, int*, char**);
#endif

extern char *aux_fltvec_to_str(int,float*);
extern float *aux_str_to_fltvec(int*,char*);

extern int is_legal_geometry(char*);

/**********************************************************************

   Two general routines to append to a singly or
   doubly linked list.
   Requires that structs start with
   *next, *prev - pointers [!!! in this order]

   pList must be non-null.

**********************************************************************/

extern void neo_append_el(void*, void*);
extern void neo_append2_el(void*, void *);
extern void *neo_remove_el(void*, void *);
extern void *neo_remove2_el(void*, void *);

