
#define NEO_FLAG_OPTION   1
#define NEO_INT_OPTION    2
#define NEO_FLOAT_OPTION  3
#define NEO_TEXT_OPTION   4

  typedef struct neo_option_{
     struct neo_option_ *next;
     char *pcName;
     char *pcInfo;
     int  iType;  /* one of NEO_FLAG_OPTION, NEO_INT_OPTION,
                            NEO_FLOAT_OPTION, NEO_TEXT_OPTION */
     void *pAdr;  /* where to find the value */
     int iDoFree; /* set when buffer was allocated 
                     neo_add_option routine */
     union {
       int (*legal_int)(int);
       int (*legal_float)(float);
       int (*legal_text)(char*);
     } is;
  } neo_option_t;

extern int  giNeoArgs;
extern char **gppcNeoArg;

int   *neo_add_flag_option(int*,char*,char*);
int   *neo_add_int_option(int*,int,int(*)(int),char*,char*);
float *neo_add_float_option(float*,float,int(*)(float),char*,char*);
char  **neo_add_text_option(char**,char*,int(*)(char*),char*,char*);
int   neo_set_flag_option(char*,int);
int   neo_set_int_option(char*,int);
int   neo_set_float_option(char*,float);
int   neo_set_text_option(char*,char*);
int   neo_get_flag_option(char*);
int   neo_get_int_option(char*);
float neo_get_float_option(char*);
char *neo_get_text_option(char*);
void  neo_init_options(FILE*, int, char**);
void  neo_fprintf_options_and_infos(FILE*);
void  neo_fprintf_options_and_values(FILE*);
