#ifndef _D2_net_H_
#define _D2_net_H_

#include <stdio.h>
#include <stdarg.h>
#include "topology.h"

class d2_node: public node {  friend class d2_net;
   // the base class to make a d2-lattice-node:
public:
   float fX,fY;       // node location in projected d2 (sphere-Model)
   int iRadialDist;   // radial dist from center (in lattice units)
   d2_node(int iIdx, int iNumOrder): node(iIdx,iNumOrder) {};
   ~d2_node(void) { free(ppNb); }
};

class d2_net: public topology {
   int iMaxRadius;
   float fD2InvEdgeLength;
   d2_node **ppNode;
 public:
   d2_node *get_node(int i) { return ppNode[i]; } 
   float *get_pos(int); 
   float dist0(float*,int);      // distance between point and a node
   float dist1(int,int);         // distance between point and a node
   float dist(float*,float*);    // distance between two points
   void translate(float*, float*);  // translation
   void rotate(float*, float*);     // rotation
   int create_search_range(int**);  // create search range array & ret dim 
   d2_net(int); 
   virtual ~d2_net(void);
};

#endif
