#ifndef __DATA_SET_H
   #define __DATA_SET_H

#include <stdio.h>

class data_set{
private:
  int iAllocated;   /* nr of allocated elements of ppfData */
  int iBytes;       /* bytesize per data el */
  int iFirst;       /* index of first data el */
  float **ppfData;  /* ptr to start of data array */
public:
  int iNumItems;    /* nr of data elements held */
  int iDimInp;      /* input dimension */
  int iDimOut;      /* output dimension */
  data_set(int,int,int);
  virtual ~data_set(void);
  virtual int eprintf(FILE*,const char*,...);  /* for diagnostics */
  void clear(void);
  int add_item(float*,float*);
  int ins_item(int,float*,float*);
  int del_item(int);
  int set_item(int,float*,float*);
  int get_item(int,float*,float*);
  float *ref_item(int);
  float **for_items(float**, int*);
};

#endif

