/******************************************************************************
 *
 *	HEADER filepath  etc.
 *
 * $Source: /vol/ni/src/cvsroot/nst5/foldersrc/fpath.h,v $
 * $Log: fpath.h,v $
 * Revision 1.1  1997/12/04 11:12:04  walter
 * finding files by name and search path
 *

 *****************************************************************************/
#ifndef _FPATH_H
#define _FPATH_H

#include <sys/types.h>
#include <sys/stat.h>
#define FPATHLEN 199

struct fpath_t {
  char* tDesc;			/* path type description */
  char* tPath;			/* path colon or withe-space separated */
  int   iPathMem;		/* 0=Static else dynamic allocated */
  char  acFoundName[FPATHLEN];	/* found absolute or relative file name */
  struct stat sStat;		/* stat result */
};
typedef struct fpath_t fpath_t;

extern fpath_t * fpath_new(char *tDescription, char *tPathInit);
				/* create new object, string referenced  */

extern fpath_t * fpath_set(fpath_t* psF, /* fpath struct */
			   char* tNewPath /* new path segment, replace previous */
			   );

extern fpath_t * fpath_add(fpath_t* psF, char* tAddPath, int iAppend);
				/* add path to string dynamically, append/prepend */
#define FPATH_PREPEND 0
#define FPATH_APPEND  1

extern char * fpath_mod(fpath_t* psF, /* fpath struct */
			char* tAddPath, /* new path segment */
			char cMode	/* indicate if set, appended, or prepended */
			);
extern char*  fpath_findName(fpath_t* psF, char* tFileName);
				/* return acFoundName or NULL */

extern FILE*  fpath_fopen(char* acRet, fpath_t* psF, char* tFileName, char *mode);
				/* return opened file  */
extern char*  fpath_getLastName(fpath_t * psF);
				/* return last file name found */
extern char*  fpath_getComment(void);
				/* return last global fpath_fopen() comment */

extern int    fpath_fclose (FILE *fp);
extern int    fcloseNotStd (FILE *fp);
				/* close file descriptor not std-in, -out, or -err */

extern void fpath_fprint(FILE* fp, fpath_t* psF);
				/* print routine */
extern void fpath_free(fpath_t * psF);
				/* free resource */


#endif



