#ifndef __NEO5_1_H
#define __NEO5_1_H

#define BY_REF_SYMBOL    '^'

#define FOLDER_IGNORED   -1
#define FOLDER_NOT_FOUND  0
#define FOLDER_ADDED      1

#define ICONBOX_OF(C)  ((NstFolderPrivate_t*)((C)->pPrivate))->uIconBox
#define PATH_OF(C)     ((NstFolderPrivate_t*)((C)->pPrivate))->pcPath
#define PACKAGE_PATH_OF(C) ((NstFolderPrivate_t*)((C)->pPrivate))->pcPackagePath
#define DLIB_HANDLE_OF(C) ((NstFolderPrivate_t*)((C)->pPrivate))->pDlibHandle
#define GROUP_OF(C) ((NstFolderPrivate_t*)((C)->pPrivate))->iGroup
#define MAJOR_VERSION_OF(C) ((NstFolderPrivate_t*)((C)->pPrivate))->iMajorVersion
#define MINOR_VERSION_OF(C) ((NstFolderPrivate_t*)((C)->pPrivate))->iMinorVersion
#define USE_FULL_PATH_OF(C) ((NstFolderPrivate_t*)((C)->pPrivate))->iUseFullPath
typedef struct NstFolderPrivate_{
   char *pcPath;         /* if !NULL, folder is loadable and this is the path
                            [including the actual folder name at its end]     */
   char *pcPackagePath;  /* path list where to search manpages and examples   */
   void *pDlibHandle;    /* if !NULL, dynamic folder and this is the handle   */
   int  iGroup;          /* id of group to which this folder belongs          */
   int  iMajorVersion;   /* major folder version                              */
   int  iMinorVersion;   /* minor folder version                              */
   int  iUseFullPath;    /* flag: if true, save full path name, basename else */
   unitptr uIconBox;     /* the host for the items in this folder             */
} NstFolderPrivate_t;

extern void NeoPrependPath (NstFolder_t *psThisFolder, char *pcPath);
extern int NeoAddContentsOfDynamicFolder (char *pcSharedLibName, 
                                          char *pcTargetFolder);
extern int NeoAddLoadableFolder (char *pcFolderPath, char *pcFolderName);

#endif /* __NEO5_1_H */
