/******************************************************************************
 *
 * neo6.h  -  headers for neo6.c
 *
 * Copyright Helge Ritter, 1994
 *
 * $Source: /vol/ni/src/cvsroot/nst5/neosrc/neo6.h,v $
 * $Log: neo6.h,v $
 * Revision 1.6  2005/09/02 13:44:12  rhaschke
 * merge with Helge's NST7 version: simplified event loop, smaller neo-files
 * major cleanup of compiler switches, declarations, etc.
 *
 * Revision 1.5  1997/10/13 16:42:30  helge
 * - extensive clean-up in src-generator routines (mainly neo6.c)
 * - some bugs in neo remake_unit removed (neo11.c)
 * - better src generation, better diagnostics (neo1,2,main)
 * - some wrappers corrected   (mainly SRCLINEs)
 * - unit funct_gen now obsolete and hidden (but kept); use
 *   function_gen for new work (differs only in wrapper)
 *
 * Revision 1.3  1997/04/02 12:47:00  helge
 * several minor corrections, among them: better handling of operator scopes,
 * ~-expansion in .neofolders-file, unloading of dynamic folders now works,
 * save gz file now safeguarded against specification of non-existent dir.
 *
 * Revision 1.2  1997/03/13  09:59:25  jan
 * Folder neuron extracted. Dependency cleanup No. 1: no more nst_defs.h.
 *
 * Revision 1.7  1997/01/31 20:02:39  helge
 * (minor changes or only touched)
 *
 * Revision 1.6  1997/01/14  14:35:12  helge
 * changes 135-139 bugs 131,132, numerous further small changes to
 * take care of (almost) all warnings under -Wall -O2
 * !!! Some Neo-structs have changed, trust the Makefile or  !!!
 * !!! recompile EVERYTHING !!!
 *
 * Revision 1.5  1995/08/02  16:45:00  helge
 * Load/Save can now use gzipped files.
 * Src code generation now works also for new pin types.
 *
 * Revision 1.2  1995/07/16 20:58:56  helge
 * added support for sending units to remote host(s) [in neo8.c]
 * better interface for container_unit
 *
 * Revision 1.1  1995/03/06  15:17:34  helge
 * source files for neo kernel.
 *
 *
 *****************************************************************************/
#ifndef __NEO6_H
#define __NEO6_H

/* these control source code generation */
extern int giMakeObjectOnly,giVarsFromDeclarations,giVarsFromArgList,giVarsFromGetOpt; 

extern char* MakeStatementForStringSubst(char *pcStr,unitptr uHostIcon);
extern void NeoMakeCodeForConstructor (FILE *fp, int iCount, char *acType, int *aiIndex, unitptr uTemp);
extern char* NeoChangeIndentation (char *pcIndent, int iDelta);
extern int NeoFindArgsAndTheirTypesAndSlotNrsFor(unitptr uIcon, int iGlobal, char *pcType, int *piIndex);
extern int NeoInsertWindowSize(char *pc, char cWhich, unitptr uOrig);

extern void NeoMakeCode(FILE *fpOut, FILE *fpHdr,
                        FILE *fpSrcTemplate, char *pcName,unitptr uIcon);
extern int NeoMakeMakeFile(FILE *fp, char *pcTemplate, char *pcName, 
                           unitptr uIcon);
extern char *NeoVarStr(char cType, int i, unitptr uWdw);
extern int isFullConnection(unitptr uWire);
extern int isFullConnection1(unitptr uWire);

#endif
