#ifndef __NEO_EVENT_H
#define __NEO_EVENT_H

#define FocusQuery 999    /* a sure non X-number */

typedef struct neo_event__t {
   int iType;  /* Neo event type: usually one of the X types,
                  additionally QueryFocus */
   unsigned long iKey;
   int iButton;
   int iWindow;
   int aiButton[3];
   int iMx, iMy;  /* mouse ptr coord rel. to curr. window */
   NstIconWdw_t *psWdw;    /* the icon window or NULL */ 
   XEvent sEv;    /* a copy of the original X event */
} neo_event_t;

extern  neo_event_t *NeoGetCurrentEvent(void);

typedef int(*handler_t)(neo_event_t*,void*);
extern  void NeoRegisterAction(handler_t, void *pData);
extern  void NeoRegisterStickyAction(handler_t, void *pData);

#define EVENT_TYPE(P) (P)->iType
#define NO_BUTTONS(P) (!(P)->aiButton[0] && !(P)->aiButton[1] && !(P)->aiButton[2])

#endif /* __NEO_EVENT_H */
