
#ifndef __NST_IPC_AUX_H
#define __NST_IPC_AUX_H

/* N rounded up to smallest multiple of sizeof(float): */
#define ALIGN(N) (sizeof(float)*(1+((N)/sizeof(float))))

/* struct at the beginning of each segment: */

typedef struct segment_hdr_t_{
  size_t       iOffset;      /* offset to data relative to start of segment */
  unsigned int iNumUpdates;  /* nr of write accesses so far */
  unsigned int iNumReaders,iNumWriters;
} segment_hdr_t;

extern void InitSegmentHeader(char*,char*);
extern void InitExport(char*,char*);
extern char *GetFormatOfExport(char*);
extern char *GetDataStartOfExport(char*);
extern unsigned int GetNumUpdatesOfExport(char*);
extern void IncNumUpdatesOfExport(char*);
extern segment_hdr_t *GetHeaderOfExport(char*);
extern void delete_item_by_key(char*);
extern void zero_readers_of_item(char*);
extern int suspend_item_by_key(char*);
extern char *begin_export(char*,int,int*);
extern char *begin_import(char*,int*,int*);
extern void end_import(char*,int);
extern void do_remove_export(char*);
extern void end_export(char*,int);

#endif

