#ifndef __NST_PLOT_H
#define __NST_PLOT_H


extern int nst_is_plot_unit(unitptr);
extern int nst_is_plot3d_unit(unitptr);

extern unitptr mouse_xy(char *pcWdw, char *fmt, unitptr dest);

/* CHANGED! Routine with orig. interface is now mouse_xy1() below! */

/* waits until middle button of mouse is pressed.
   On return, output field Y_out[2] contains location
   of mouse pointer with respect to lower left corner
   of window w. Argument fmt is presently ignored
   (may be set to NULL).
*/

extern unitptr mouse_xy1(int,char*,unitptr);

extern unittype *xyplot(int n, char *windesc, char *fmt, 
   float xmin, float xmax, float ymin, float ymax, unittype *dest);

/* same routine, more systematic name: */

extern unittype *plot_xy(int n, char *windesc, char *fmt, 
   float xmin, float xmax, float ymin, float ymax, unittype *dest);

/* make a coordinate system for superimposint n plots. 
   Character string windesc must contain the
   following fields:
   title xpos ypos dx dy
   Character string fmt must contain a field %i1:i2:i3m for
   each plot, specifying color, shape and size of markers used
   for that plot.
*/

extern unitptr plot_series(int n, char *windesc, char *fmt,
          float fTimeSpan, float fDt, float ymi, float yma, unittype *dest);

extern unitptr plot_vec(
   int n,           /* vector dimension */
   char *tWdw,      /* window descriptor (title, xll, yll,
                       width, height) */
   char *tFmt,      /* format string */
   float fMin,       /* lower limit of range */
   float fMax,       /* upper limit of range */
   unitptr uHost    /* host unit */
);

extern unitptr plot3d_unit(char*,char*,unitptr);
extern void nst_dat_to_pix3f(float,float,float,float*,float*);
extern void nst_dat_to_pix3i(float,float,float,int*,int*);
extern void nst_datvec_to_pix3f(float*,float*,float*,float*,float*,int);
extern void nst_datvec_to_pix3i(float*,float*,float*,int*,int*,int);
extern int  ctrl_plot3d_unit(int, unitptr);

#endif
